//##protect##"FileHeader"
/** @file Read16DigitalInputs.c
 *
 *  @authors S. Beuque, C. Guinot, J. Krauth, N. Reibel, J. Rose, L. Sartory, S. Weber
 *  @date    Creation: 01.02.2013
 *  @date    $LastChangedDate: 2013-02-01 17:00:03 +0100 (Fr, 01. Feb 2013) $
 *  @version $LastChangedRevision: 3770 $
 *
 *  @par DESCRIPTION
 *  Reads the sixteen digital inputs of the board 
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2009 - 2013 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/
//##protect##"FileHeader"

#include "StdAfx.h"

//##protect##"Read16DigitalInputs_Head"
//##protect##"Read16DigitalInputs_Head"

int _tmain(int argc, _TCHAR *argv[])
{
	INT    i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
//##protect##"Read16DigitalInputs_VariablesDeclaration"
	WORD   b_Value = 0;
//##protect##"Read16DigitalInputs_VariablesDeclaration"

	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);

	printf("/****************************************************************************\\\n"
	       "|*                        Read16DigitalInputs sample                        *|\n"
	       "|****************************************************************************|\n"
	       "|* Reads the sixteen digital inputs of the board                            *|\n"
	       "\\****************************************************************************/\n\n");

//##protect##"Read16DigitalInputs_Start"
//##protect##"Read16DigitalInputs_Start"

	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);
	if (i_ReturnValue != 0)
	{
		fprintf(stderr, "i_Utils_OpenBoard failed: %d\n", i_ReturnValue);
		_getch();
		return i_ReturnValue;
	}

//##protect##"Read16DigitalInputs_Body"
	do
	{
		i_ReturnValue = i_PCIe1016_Read16DigitalInputs(h_BoardHandle, &b_Value);
		if (i_ReturnValue == 0)
			printf("\rValue of the digital inputs : 0x%-5x", b_Value);
		else
		{
			fprintf(stderr, "%s \n", pc_PCIe1016_GetLastError(h_BoardHandle));
			i_PCIe1016_CloseBoard(h_BoardHandle);
			_getch();
			return i_ReturnValue;
		}
		Sleep(10);
	} while (!_kbhit());
	// Catch the previous _kbhit
	_getch();
//##protect##"Read16DigitalInputs_Body"

	i_ReturnValue = i_PCIe1016_CloseBoard(h_BoardHandle);
	if (i_ReturnValue != 0)
	{
		fprintf(stderr, "i_PCIe1016_CloseBoard failed: %d\n", i_ReturnValue);
		_getch();
		return i_ReturnValue;
	}

//##protect##"Read16DigitalInputs_End"
//##protect##"Read16DigitalInputs_End"

	printf("\nPress any key to exit the sample...\n");
	_getch();
	return i_ReturnValue;
}
