//##protect##"FileHeader"
/** @file Read1DigitalInput.c
 *
 *  @authors S. Beuque, C. Guinot, J. Krauth, N. Reibel, J. Rose, L. Sartory, S. Weber
 *  @date    Creation: 03.12.2012
 *  @date    $LastChangedDate: 2012-12-07 10:36:45 +0100 (Fr, 07. Dez 2012) $
 *  @version $LastChangedRevision: 3640 $
 *
 *  @par DESCRIPTION
 *  Reads one digital input of the board 
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2009 - 2012 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/
//##protect##"FileHeader"

#include "StdAfx.h"

//##protect##"Read1DigitalInput_Head"
//##protect##"Read1DigitalInput_Head"

int _tmain(int argc, _TCHAR *argv[])
{
	INT    i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
//##protect##"Read1DigitalInput_VariablesDeclaration"
	BYTE   b_Channel = 0;
	BYTE   b_Value = 0;
//##protect##"Read1DigitalInput_VariablesDeclaration"

	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);

	printf("/****************************************************************************\\\n"
	       "|*                         Read1DigitalInput sample                         *|\n"
	       "|****************************************************************************|\n"
	       "|* Reads one digital input of the board                                     *|\n"
	       "\\****************************************************************************/\n\n");

//##protect##"Read1DigitalInput_Start"
//##protect##"Read1DigitalInput_Start"

	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);
	if (i_ReturnValue != 0)
	{
		fprintf(stderr, "i_Utils_OpenBoard failed: %d\n", i_ReturnValue);
		_getch();
		return i_ReturnValue;
	}

//##protect##"Read1DigitalInput_Body"
	if (i_ReturnValue == 0)
	{
		b_Channel = (BYTE)ll_Utils_ReadInteger(0, 15, "Which channel do you want to read (0 to 15)?");
		
		do
		{
			i_ReturnValue = i_PCIe1016_Read1DigitalInput(h_BoardHandle, b_Channel, &b_Value);
			if (i_ReturnValue == 0)
				printf("\rValue of the channel %d: 0x%x", b_Channel, b_Value);
			else
			{
				fprintf(stderr, "%s \n", pc_PCIe1016_GetLastError(h_BoardHandle));
				i_PCIe1016_CloseBoard(h_BoardHandle);
				_getch();
				return i_ReturnValue;
			}
			Sleep(100);
		} while (!_kbhit());

		// Catch the previous kbhit()
		_getch();
	}
//##protect##"Read1DigitalInput_Body"

	i_ReturnValue = i_PCIe1016_CloseBoard(h_BoardHandle);
	if (i_ReturnValue != 0)
	{
		fprintf(stderr, "i_PCIe1016_CloseBoard failed: %d\n", i_ReturnValue);
		_getch();
		return i_ReturnValue;
	}

//##protect##"Read1DigitalInput_End"
//##protect##"Read1DigitalInput_End"

	printf("\nPress any key to exit the sample...\n");
	_getch();
	return i_ReturnValue;
}
