#include "stdafx.h"
//##protect##"AdditionalIncludeFiles"
//##protect##"AdditionalIncludeFiles"


/**
* This function will manage the opening of the board
**/
INT i_Utils_OpenBoard(HANDLE *ph_BoardHandle)
{
	BYTE b_NbrOfBoards = 0;
	BYTE b_Cpt = 0;
	BYTE b_Board = 0;
	DWORD dw_Temp = 0;
	DWORD dw_OpenMode = 0;
	INT i_ReturnValue = 0;
	CHAR pc_Identifier[50];
	CHAR *pc_OpenFunction[2] = {"i_PCIe1016_OpenBoardViaIndex", "i_PCIe1016_OpenBoardViaIdentifier"};
	DWORD ul_UINumber;
	DWORD ul_DeviceNumber;
	DWORD ul_BusNumber;
	DWORD ul_Address0;
	DWORD ul_Address1;
	DWORD ul_Address2;
	DWORD ul_Address3;
	BYTE b_Interrupt;
	DWORD dw_Version = 0;

	if (i_PCIe1016_GetDLLVersion(&dw_Version) == 0)
		printf("\n DLL version : %d.%d",(dw_Version >> 24) & 0xFF, (dw_Version >> 16) & 0xFF );

	i_ReturnValue = i_PCIe1016_GetNumberOfBoards(&b_NbrOfBoards);

	if (i_ReturnValue == 0)
	{
		printf("\n i_PCIe1016_GetNumberOfBoards OK");
		printf("\n Number of boards found: %d \n", b_NbrOfBoards);
		
		if (b_NbrOfBoards > 0)
		{
			for (b_Cpt = 0; b_Cpt < b_NbrOfBoards; b_Cpt++)
			{
				i_ReturnValue = i_PCIe1016_GetBoardInformation(b_Cpt, 50, pc_Identifier, &ul_UINumber, &ul_DeviceNumber, &ul_BusNumber, &ul_Address0, &ul_Address1, &ul_Address2, &ul_Address3, &b_Interrupt);

				if (i_ReturnValue == 0)
				{
					printf("\n\n Board %hu information:",b_Cpt);
					printf("\n Identifier: %s",pc_Identifier);
					printf("\n UI number: 0x%lx",ul_UINumber);
					printf("\n Device number: 0x%lx",ul_DeviceNumber);
					printf("\n Bus number: 0x%lx",ul_BusNumber);
					printf("\n Base address 0: 0x%lx",ul_Address0);
					printf("\n Base address 1: 0x%lx",ul_Address1);
					printf("\n Base address 2: 0x%lx",ul_Address2);
					printf("\n Base address 3: 0x%lx",ul_Address3);
					printf("\n Interrupt: %hu",b_Interrupt);
				}
			}
			
			do
			{
				printf("\n Do you want to open the board via index (0) or via identifier (1)?");
				scanf_s("%lu", &dw_OpenMode);
			} while (dw_OpenMode > 1);
			
			if (dw_OpenMode == 0)
			{
				do
				{
					printf("\n Select the board you want to use (0 to %d):",b_NbrOfBoards-1);
					scanf_s("%lu",&dw_Temp);
				} while (dw_Temp >= b_NbrOfBoards);
				
				b_Board = (BYTE)dw_Temp;
			}
			
			else
			{
				printf("\n Enter the board identifier:");
				scanf_s("%s",pc_Identifier);
			}
			
			if (dw_OpenMode == 0)
				i_ReturnValue = i_PCIe1016_OpenBoardViaIndex(b_Board, ph_BoardHandle);
			else
				i_ReturnValue = i_PCIe1016_OpenBoardViaIdentifier(pc_Identifier, ph_BoardHandle);

			if (i_ReturnValue == 0)
			{
				printf("\n %s OK", pc_OpenFunction[dw_OpenMode]);
				if (i_PCIe1016_GetDeviceDriverVersion(*ph_BoardHandle, &dw_Version) == 0)
					printf("\n Device driver version: %d.%d", (dw_Version >> 24) & 0xFF, (dw_Version >> 16) & 0xFF);
			}
			else
				printf("\n %s Error : %d", pc_OpenFunction[dw_OpenMode], i_ReturnValue);
		}
		else
			i_ReturnValue = -1;
	}
	else
		printf("\n i_PCIe1016_GetNumberOfBoards Error : %d", i_ReturnValue);

	return i_ReturnValue;
}


/**
* Interrupt routine that can be used in the samples
* If you register this interrupt routine thanks to the function i_PCIe1016_SetBoardIntRoutine,
* this function will be called each time the board generates an interruption
**/
void InterruptRoutine(HANDLE deviceHandle,
					  BYTE fifoOverflow,
					  DWORD interruptSource,
					  DWORD interruptMask,
					  PWORD args,
					  DWORD argsCount)
{
	UNREFERENCED_PARAMETER(deviceHandle);
	UNREFERENCED_PARAMETER(fifoOverflow);
	UNREFERENCED_PARAMETER(interruptSource);
	UNREFERENCED_PARAMETER(interruptMask);
	UNREFERENCED_PARAMETER(args);
	UNREFERENCED_PARAMETER(argsCount);

	/* Switch through the possible interrupt sources */
	
//##protect##"PossibleInterruptSources"
//##protect##"PossibleInterruptSources"

}


/**
* Enable to read a ulong from the keyboard
**/
void ReadUlong(char *description,
               ULONG minValue,
			   ULONG maxValue,
               ULONG *readValue)
{
	do
	{
		printf("%s", description);
		_flushall();
		scanf_s("%u", readValue);
	}
	while((*readValue < minValue) || (*readValue > maxValue));
}


//##protect##"AdditionalUtilsFunctions"
//##protect##"AdditionalUtilsFunctions"

