//##protect##"FileHeader"
/** @file DllImport.cs
 *
 *  @authors S. Beuque, C. Guinot, J. Krauth, N. Reibel, J. Rose, L. Sartory, S. Weber
 *  @date    Creation: 01.02.2013
 *  @date    $LastChangedDate$
 *  @version $LastChangedRevision$
 *
 *  @par DESCRIPTION
 *  PCI1016.dll imports 
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2009 - 2013 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/
//##protect##"FileHeader"

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace PCIe1016_NET
{
    /// <summary>
    /// Contains the prototypes of the DLL functions
    /// </summary>
    public class DllImport
    {
        /// <summary>
        /// Definition of the user interruption function prototype
        /// </summary>
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void InterruptFunctionEventHandler(IntPtr handle, Byte overflow, UInt32 source, UInt32 mask, IntPtr args, UInt32 argsSize);

#region "Generic"
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_GetNumberOfBoards(out Byte pb_NbrOfBoards);
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_GetBoardInformation(Byte b_BoardIndex, UInt32 dw_IdentifierStringSize, out Byte[] pc_Identifier, out UInt32 pdw_UINumber, out UInt32 pdw_DeviceNumber, out UInt32 pdw_BusNumber, out UInt32 pdw_BaseAddress0, out UInt32 pdw_BaseAddress1, out UInt32 pdw_BaseAddress2, out UInt32 pdw_BaseAddress3, out Byte pb_Interrupt);
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_OpenBoardViaIndex(Byte b_BoardIndex, out IntPtr ph_DeviceHandle);
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_OpenBoardViaIdentifier(out Byte[] pc_Identifier, out IntPtr ph_DeviceHandle);
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_CloseBoard(IntPtr h_DeviceHandle);
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_GetDLLVersion(out Int32 pdw_Version);
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_GetDeviceDriverVersion(IntPtr h_DeviceHandle, out Int32 pdw_Version);
		[DllImport("PCIe1016.dll")]
		public static extern IntPtr pc_PCIe1016_GetLastError(IntPtr h_DeviceHandle);
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_SetBoardIntRoutine(IntPtr h_DeviceHandle, [MarshalAs(UnmanagedType.FunctionPtr)] InterruptFunctionEventHandler interruptFunction);
		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_ResetBoardIntRoutine(IntPtr h_DeviceHandle);
#endregion

#region "PCIe1016"

#endregion
#region "DigitalInput"

		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_Read1DigitalInput(IntPtr deviceHandle, Byte channel, out Byte value);

		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_Read4DigitalInputs(IntPtr deviceHandle, Byte port, out Byte value);

		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_Read8DigitalInputs(IntPtr deviceHandle, Byte port, out Byte value);

		[DllImport("PCIe1016.dll")]
		public static extern short i_PCIe1016_Read16DigitalInputs(IntPtr deviceHandle, out UInt16 value);

#endregion
#region "Misc"
//##protect##"DllImportMisc"
//##protect##"DllImportMisc"
#endregion
    }
}
